/* vim:set et sw=2 cin cino=t0,f0,(0,{s,>2s,n-s,^-s,e2s: */
/*
 * Copyright © 2016 Collabora Ltd.
 *
 * SPDX-License-Identifier: MPL-2.0
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#include <glib.h>
#include <gio/gio.h>


/*
 * Declaration of the org.apertis.Rhosydd1.Vehicle D-Bus interface.
 */

static const GDBusArgInfo vehicle1_interface_arg_zone_path =
{
  -1,  /* ref count */
  (gchar *) "zone_path",
  (gchar *) "s",
  NULL
};

static const GDBusArgInfo vehicle1_interface_arg_attribute_name =
{
  -1,  /* ref count */
  (gchar *) "attribute_name",
  (gchar *) "s",
  NULL
};

static const GDBusArgInfo vehicle1_interface_arg_value_out =
{
  -1,  /* ref count */
  (gchar *) "value",
  (gchar *) "(vdx)",
  NULL
};

static const GDBusArgInfo vehicle1_interface_arg_value_in =
{
  -1,  /* ref count */
  (gchar *) "value",
  (gchar *) "v",
  NULL
};

static const GDBusArgInfo vehicle1_interface_arg_attributes_out =
{
  -1,  /* ref count */
  (gchar *) "attributes",
  (gchar *) "a(ss(vdx)(uu))",
  NULL
};

static const GDBusArgInfo vehicle1_interface_arg_current_time =
{
  -1,  /* ref count */
  (gchar *) "current_time",
  (gchar *) "x",
  NULL
};

static const GDBusArgInfo vehicle1_interface_arg_changed_attributes =
{
  -1,  /* ref count */
  (gchar *) "changed_attributes",
  (gchar *) "a(ss(vdx)(uu))",
  NULL
};

static const GDBusArgInfo vehicle1_interface_arg_invalidated_attributes =
{
  -1,  /* ref count */
  (gchar *) "invalidated_attributes",
  (gchar *) "a(ss(uu))",
  NULL
};

static const GDBusArgInfo vehicle1_interface_arg_changed_attributes_metadata =
{
  -1,  /* ref count */
  (gchar *) "changed_attributes_metadata",
  (gchar *) "a(ss(uu))",
  NULL
};

static const GDBusArgInfo vehicle1_interface_arg_attribute_metadata_out =
{
  -1,  /* ref count */
  (gchar *) "metadata",
  (gchar *) "(uu)",
  NULL
};

static const GDBusArgInfo vehicle1_interface_arg_attributes_metadata_out =
{
  -1,  /* ref count */
  (gchar *) "attributes_metadata",
  (gchar *) "a(ss(uu))",
  NULL
};

static const GDBusArgInfo vehicle1_interface_arg_subscriptions =
{
  -1,  /* ref count */
  (gchar *) "subscriptions",
  (gchar *) "a(ssa{sv})",
  NULL
};

static const GDBusArgInfo vehicle1_interface_arg_unsubscriptions =
{
  -1,  /* ref count */
  (gchar *) "unsubscriptions",
  (gchar *) "a(ssa{sv})",
  NULL
};

static const GDBusArgInfo *vehicle1_interface_get_attribute_in_args[] =
{
  &vehicle1_interface_arg_zone_path,
  &vehicle1_interface_arg_attribute_name,
  NULL,
};
static const GDBusArgInfo *vehicle1_interface_get_attribute_out_args[] =
{
  &vehicle1_interface_arg_current_time,
  &vehicle1_interface_arg_value_out,
  &vehicle1_interface_arg_attribute_metadata_out,
  NULL,
};
static const GDBusMethodInfo vehicle1_interface_get_attribute =
{
  -1,  /* ref count */
  (gchar *) "GetAttribute",
  (GDBusArgInfo **) vehicle1_interface_get_attribute_in_args,
  (GDBusArgInfo **) vehicle1_interface_get_attribute_out_args,
  NULL,  /* annotations */
};

static const GDBusArgInfo *vehicle1_interface_set_attribute_in_args[] =
{
  &vehicle1_interface_arg_zone_path,
  &vehicle1_interface_arg_attribute_name,
  &vehicle1_interface_arg_value_in,
  NULL,
};
static const GDBusMethodInfo vehicle1_interface_set_attribute =
{
  -1,  /* ref count */
  (gchar *) "SetAttribute",
  (GDBusArgInfo **) vehicle1_interface_set_attribute_in_args,
  NULL,  /* out args */
  NULL,  /* annotations */
};

static const GDBusArgInfo *vehicle1_interface_get_all_attributes_in_args[] =
{
  &vehicle1_interface_arg_zone_path,
  NULL,
};
static const GDBusArgInfo *vehicle1_interface_get_all_attributes_out_args[] =
{
  &vehicle1_interface_arg_current_time,
  &vehicle1_interface_arg_attributes_out,
  NULL,
};
static const GDBusMethodInfo vehicle1_interface_get_all_attributes =
{
  -1,  /* ref count */
  (gchar *) "GetAllAttributes",
  (GDBusArgInfo **) vehicle1_interface_get_all_attributes_in_args,
  (GDBusArgInfo **) vehicle1_interface_get_all_attributes_out_args,
  NULL,  /* annotations */
};

static const GDBusArgInfo *vehicle1_interface_get_attribute_metadata_in_args[] =
{
  &vehicle1_interface_arg_zone_path,
  &vehicle1_interface_arg_attribute_name,
  NULL,
};
static const GDBusArgInfo *vehicle1_interface_get_attribute_metadata_out_args[] =
{
  &vehicle1_interface_arg_current_time,
  &vehicle1_interface_arg_attribute_metadata_out,
  NULL,
};
static const GDBusMethodInfo vehicle1_interface_get_attribute_metadata =
{
  -1,  /* ref count */
  (gchar *) "GetAttributeMetadata",
  (GDBusArgInfo **) vehicle1_interface_get_attribute_metadata_in_args,
  (GDBusArgInfo **) vehicle1_interface_get_attribute_metadata_out_args,
  NULL,  /* annotations */
};

static const GDBusArgInfo *vehicle1_interface_get_all_attributes_metadata_in_args[] =
{
  &vehicle1_interface_arg_zone_path,
  NULL,
};
static const GDBusArgInfo *vehicle1_interface_get_all_attributes_metadata_out_args[] =
{
  &vehicle1_interface_arg_current_time,
  &vehicle1_interface_arg_attributes_metadata_out,
  NULL,
};
static const GDBusMethodInfo vehicle1_interface_get_all_attributes_metadata =
{
  -1,  /* ref count */
  (gchar *) "GetAllAttributesMetadata",
  (GDBusArgInfo **) vehicle1_interface_get_all_attributes_metadata_in_args,
  (GDBusArgInfo **) vehicle1_interface_get_all_attributes_metadata_out_args,
  NULL,  /* annotations */
};

static const GDBusArgInfo *vehicle1_interface_update_subscriptions_in_args[] =
{
  &vehicle1_interface_arg_subscriptions,
  &vehicle1_interface_arg_unsubscriptions,
  NULL,
};
static const GDBusMethodInfo vehicle1_interface_update_subscriptions =
{
  -1,  /* ref count */
  (gchar *) "UpdateSubscriptions",
  (GDBusArgInfo **) vehicle1_interface_update_subscriptions_in_args,
  NULL,  /* out args */
  NULL,  /* annotations */
};

static const GDBusMethodInfo *vehicle1_interface_methods[] =
{
  &vehicle1_interface_get_attribute,
  &vehicle1_interface_set_attribute,
  &vehicle1_interface_get_all_attributes,
  &vehicle1_interface_get_attribute_metadata,
  &vehicle1_interface_get_all_attributes_metadata,
  &vehicle1_interface_update_subscriptions,
  NULL,
};

static const GDBusArgInfo *vehicle1_interface_attributes_changed_args[] =
{
  &vehicle1_interface_arg_current_time,
  &vehicle1_interface_arg_changed_attributes,
  &vehicle1_interface_arg_invalidated_attributes,
  NULL,
};
static const GDBusSignalInfo vehicle1_interface_attributes_changed =
{
  -1,  /* ref count */
  (gchar *) "AttributesChanged",
  (GDBusArgInfo **) vehicle1_interface_attributes_changed_args,
  NULL,  /* annotations */
};

static const GDBusArgInfo *vehicle1_interface_attributes_metadata_changed_args[] =
{
  &vehicle1_interface_arg_current_time,
  &vehicle1_interface_arg_changed_attributes_metadata,
  NULL,
};
static const GDBusSignalInfo vehicle1_interface_attributes_metadata_changed =
{
  -1,  /* ref count */
  (gchar *) "AttributesMetadataChanged",
  (GDBusArgInfo **) vehicle1_interface_attributes_metadata_changed_args,
  NULL,  /* annotations */
};

static const GDBusSignalInfo *vehicle1_interface_signals[] =
{
  &vehicle1_interface_attributes_changed,
  &vehicle1_interface_attributes_metadata_changed,
  NULL,
};

static const GDBusPropertyInfo vehicle1_interface_vehicle_id =
{
  -1,  /* ref count */
  (gchar *) "VehicleId",
  (gchar *) "s",
  G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
  NULL,  /* annotations */
};

static const GDBusPropertyInfo vehicle1_interface_zones =
{
  -1,  /* ref count */
  (gchar *) "Zones",
  (gchar *) "as",
  G_DBUS_PROPERTY_INFO_FLAGS_READABLE,
  NULL,  /* annotations */
};

static const GDBusPropertyInfo *vehicle1_interface_attributes[] =
{
  &vehicle1_interface_vehicle_id,
  &vehicle1_interface_zones,
  NULL,
};

static const GDBusInterfaceInfo vehicle1_interface =
{
  -1,  /* ref count */
  (gchar *) "org.apertis.Rhosydd1.Vehicle",
  (GDBusMethodInfo **) vehicle1_interface_methods,
  (GDBusSignalInfo **) vehicle1_interface_signals,
  (GDBusPropertyInfo **) vehicle1_interface_attributes,
  NULL,  /* no annotations */
};
